#include "RTClib.h"

RTC_DS1307 rtc;

DateTime prev;
//DateTime prev (2023, 2, 19, 3, 0, 0);  //For testing minute hand transition.

void setup() {
  //Serial.begin(9600);
  for (int i = 0; i < 20; i++) {  //Save Power by writing all Digital IO LOW
     pinMode(i, OUTPUT);
  }
  pinMode(4, OUTPUT);

   if (! rtc.begin()) {
    //Serial.println("Couldn't find RTC");
    //Serial.flush();
    while (1) delay(10);
  }

  if (! rtc.isrunning()) {
    //Serial.println("RTC is NOT running, let's set the time!");
    // When time needs to be set on a new device, or after a power loss, the
    // following line sets the RTC to the date & time this sketch was compiled
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
    // This line sets the RTC with an explicit date & time, for example to set
    // January 21, 2014 at 3am you would call:
    // rtc.adjust(DateTime(2014, 1, 21, 3, 0, 0));
  }

  // When time needs to be re-set on a previously configured device, the
  // following line sets the RTC to the date & time this sketch was compiled
  // rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
  // This line sets the RTC with an explicit date & time, for example to set
  // January 21, 2014 at 3am you would call:
  // rtc.adjust(DateTime(2014, 1, 21, 3, 0, 0));

    prev = rtc.now();

  //SETUP WATCHDOG TIMER
   WDTCSR = (24);//change enable and WDE - also resets
   WDTCSR = (32);//prescalers only - get rid of the WDE and WDCE bit   //32 dec means 100000 in binary, for setting watch dog prescaller to 4 seconds.
   WDTCSR |= (1<<6);//enable interrupt mode

  //Disable ADC - don't forget to flip back after waking up if using ADC in your application ADCSRA |= (1 << 7);
  ADCSRA &= ~(1 << 7);
  
  //ENABLE SLEEP - this enables the sleep mode
  SMCR |= (1 << 2); //power down mode
  SMCR |= 1;//enable sleep

}

void loop() {
  DateTime now = rtc.now();
  //DateTime now (2023, 2, 20, 3, 0, 0);    //For testing minute hand transition.
  if (prev.day() + 1 == now.day()){
    digitalWrite(4, HIGH);   
    //delay(120000);
    for (int i = 1; i <= 27; i++){   //Sleeping the microcontroller multiple 4 second durations instead of delay (27 x 4 seconds)
    //BOD DISABLE - this must be called right before the __asm__ sleep instruction
    MCUCR |= (3 << 5); //set both BODS and BODSE at the same time
    MCUCR = (MCUCR & ~(1 << 5)) | (1 << 6); //then set the BODS bit and clear the BODSE bit at the same time
    __asm__  __volatile__("sleep");//in line assembler to go to sleep
    }                      
    digitalWrite(4, LOW); 
    prev = now;
  }
  else if (now.day() == 1){
    if (prev.day() == 28){
      digitalWrite(4, HIGH);   
      //delay(360000);  // Lets sleep instead of delay.
      for (int i = 1; i <= 80; i++){    // 80 x 4 seconds = 320 seconds not 360 but 4 second watchdog is closer to 4.5 seconds. 
      //BOD DISABLE - this must be called right before the __asm__ sleep instruction
      MCUCR |= (3 << 5); //set both BODS and BODSE at the same time
      MCUCR = (MCUCR & ~(1 << 5)) | (1 << 6); //then set the BODS bit and clear the BODSE bit at the same time
      __asm__  __volatile__("sleep");//in line assembler to go to sleep
      }                       
      digitalWrite(4, LOW);   
    }
    else if (prev.day() == 29){
      digitalWrite(4, HIGH);   
      //delay(240000);                      
      for (int i = 1; i <= 53; i++){
      //BOD DISABLE - this must be called right before the __asm__ sleep instruction
      MCUCR |= (3 << 5); //set both BODS and BODSE at the same time
      MCUCR = (MCUCR & ~(1 << 5)) | (1 << 6); //then set the BODS bit and clear the BODSE bit at the same time
      __asm__  __volatile__("sleep");//in line assembler to go to sleep
      }
      digitalWrite(4, LOW); 
    }
     else if (prev.day() == 30){
      digitalWrite(4, HIGH);
      //delay(180000);
      for (int i = 1; i <= 42; i++){
      //BOD DISABLE - this must be called right before the __asm__ sleep instruction
      MCUCR |= (3 << 5); //set both BODS and BODSE at the same time
      MCUCR = (MCUCR & ~(1 << 5)) | (1 << 6); //then set the BODS bit and clear the BODSE bit at the same time
      __asm__  __volatile__("sleep");//in line assembler to go to sleep
      }   
      digitalWrite(4, LOW); 
    }
      else if (prev.day() == 31){
      digitalWrite(4, HIGH); 
      //delay(120000);
      for (int i = 1; i <= 27; i++){
       //BOD DISABLE - this must be called right before the __asm__ sleep instruction
        MCUCR |= (3 << 5); //set both BODS and BODSE at the same time
        MCUCR = (MCUCR & ~(1 << 5)) | (1 << 6); //then set the BODS bit and clear the BODSE bit at the same time
        __asm__  __volatile__("sleep");//in line assembler to go to sleep
        }     
      digitalWrite(4, LOW); 
    }
    prev = now; 
  }

     for (int i = 1; i <= 900; i++){   // Wake up every hour to see if day has changed.
      //BOD DISABLE - this must be called right before the __asm__ sleep instruction
      MCUCR |= (3 << 5); //set both BODS and BODSE at the same time
      MCUCR = (MCUCR & ~(1 << 5)) | (1 << 6); //then set the BODS bit and clear the BODSE bit at the same time
      __asm__  __volatile__("sleep");//in line assembler to go to sleep
     }

}


ISR(WDT_vect){
  //DON'T FORGET THIS!  Needed for the watch dog timer.  This is called after a watch dog timer timeout - this is the interrupt function called after waking up
}// watchdog interrupt
